
var InspectorWidget = 
{
  ////////////////////////////////////////////////////////////////////////
  //// Inspecting
  
  inspectCapture: function()
  {
  },
  
  onInspectPopupShowing: function(aEvent)
  {
    var popup = aEvent.target;

    // Empty the popup
    while (popup.lastChild)
      popup.removeChild(popup.lastChild);

    // Get an enumerator for all open windows
    var windowWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                                  .getService(Components.interfaces.nsIWindowWatcher);
    var enumerator = windowWatcher.getWindowEnumerator();
    
    // Create a menuitem for each open window
    var index = 1;
    while(enumerator.hasMoreElements()) {
      var win = enumerator.getNext();
      
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("label", win.location);
      menuitem.setAttribute("value", index++);
      
      popup.appendChild(menuitem);
    }

  },
  
  onInspectCommand: function(aEvent)
  {
    if (aEvent.target.id == "tbtnInspect") {
      // Clicking the button inspects this very document.
      Inspectomatic.selectByClick(document);
    } else {
      // Clicking a menuitem inspects a document in another window
      var windowIndex = parseInt(aEvent.target.getAttribute("value"));
      
      var windowWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                                    .getService(Components.interfaces.nsIWindowWatcher);
      var enumerator = windowWatcher.getWindowEnumerator();
      
      var index = 1;
      while(enumerator.hasMoreElements()) {
        var win = enumerator.getNext();
        if (index++ == windowIndex) {
          Inspectomatic.selectByClick(win.document);
          win.focus();
          return;
        }
      }
    }
  },

  openDOMInspector: function(aNode)
  {
    window.openDialog("chrome://inspector/content/", "", "chrome,all,dialog=no", aNode);
  },

  openJSConsole: function()
  {
    window.openDialog("chrome://global/content/console.xul", "", "chrome,all,dialog=no");
  }

};

var InspectorWidgetKeyHandler = 
{
  handleEvent: function(aEvent)
  {
    if (aEvent.keyCode == KeyEvent.DOM_VK_UP && aEvent.shiftKey && aEvent.ctrlKey)
      InspectorWidget.openDOMInspector(document);
    else if (aEvent.keyCode == KeyEvent.DOM_VK_DOWN && aEvent.shiftKey && aEvent.ctrlKey)
      InspectorWidget.openJSConsole();
  },

};

/////////////////////////////////////////////////////////////////

window.addEventListener("keypress", InspectorWidgetKeyHandler, true);
